<?php

use Tygh\Payments\Processors\RBSPayment;

if (defined('PAYMENT_NOTIFICATION')) {

    $order_id = 0;
    if (!empty($_REQUEST['ordernumber'])) {
        $order_id = $_REQUEST['ordernumber'];
    }
    $order_info = fn_get_order_info($order_id);

    if (empty($processor_data) && !empty($order_info)) {
        $processor_data = fn_get_processor_data($order_info['payment_id']);
    }


    if (!empty($processor_data['processor_params']['logging']) && $processor_data['processor_params']['logging'] == 'Y') {
        RBSPayment::writeLog($_REQUEST, 'REQUEST: ');
    }

    //CB
    if (RBSPayment::ENABLE_CALLBACK && $_REQUEST['action'] == 'callback' ) {

        $rbsPayment = new RBSPayment($processor_data);
        $response = $rbsPayment->getOrderExtended($_REQUEST['mdOrder']);

        if (!empty($processor_data['processor_params']['logging']) && $processor_data['processor_params']['logging'] == 'Y') {
            RBSPayment::writeLog($response, 'CALLBACK RESPONSE: ');
        }

        if ($rbsPayment->isError()) {
            $pp_response['reason_text'] = $response['errorMessage'];
        } elseif ($response['orderStatus'] == 1 || $response['orderStatus'] == 2) {

//                if ($response['amount'] == round($order_info['total'] * 100)) {
            $pp_response = array(
                'order_status' => $processor_data['processor_params']['confirmed_order_status'],
                'card_number' => $response['cardAuthInfo']['pan'],
                'cardholder_name' => $response['cardAuthInfo']['cardholderName'],
                'expiry_month' => substr($response['cardAuthInfo']['expiration'], 0, 4),
                'expiry_year' => substr($response['cardAuthInfo']['expiration'], 0, -2),
                'bank' => $response['bankInfo']['bankName'],
                'ip_address' => $response['ip'],
            );
//                } else {
//                    $pp_response['reason_text'] = __("addons.rbspayment.wrong_amount");
//                }
        } else {
            $pp_response = array(
                'order_status' => 'F',
                'reason_text' => $response['actionCodeDescription'],
                'ip_address' => $response['ip'],
            );
        }
        fn_finish_payment($order_id, $pp_response);
        fn_order_placement_routines('route', $order_id, false);
        exit;
    }


    //RU
    if (!empty($order_info) && ($mode == 'return' || $mode == 'error')) {

        $pp_response = array(
            'order_status' => 'F'
        );

//        echo $order_info['payment_info']['transaction_id'] ." | " . $_REQUEST['orderId'];
//        die;
        if ($order_info['payment_info']['transaction_id'] != $_REQUEST['orderId']) {
            $pp_response['reason_text'] = __("addons.rbspayment.wrong_transaction_id");

        } else {
            $rbsPayment = new RBSPayment($processor_data);
            $response = $rbsPayment->getOrderExtended($order_info['payment_info']['transaction_id']);

            if (!empty($processor_data['processor_params']['logging']) && $processor_data['processor_params']['logging'] == 'Y') {
                RBSPayment::writeLog($response, 'RETURN RESPONSE: ');
            }

            if ($rbsPayment->isError()) {
                $pp_response['reason_text'] = $response['errorMessage'];
            } elseif ($response['orderStatus'] == 1 || $response['orderStatus'] == 2) {

//                if ($response['amount'] == round($order_info['total'] * 100)) {
                $pp_response = array(
                    'order_status' => $processor_data['processor_params']['confirmed_order_status'],
                    'card_number' => $response['cardAuthInfo']['pan'],
                    'cardholder_name' => $response['cardAuthInfo']['cardholderName'],
                    'expiry_month' => substr($response['cardAuthInfo']['expiration'], 0, 4),
                    'expiry_year' => substr($response['cardAuthInfo']['expiration'], 0, -2),
                    'bank' => $response['bankInfo']['bankName'],
                    'ip_address' => $response['ip'],
                );
//                } else {
//                    $pp_response['reason_text'] = __("addons.rbspayment.wrong_amount");
//                }
            } else {
                $pp_response = array(
                    'order_status' => 'F',
                    'reason_text' => $response['actionCodeDescription'],
                    'ip_address' => $response['ip'],
                );
            }
        }

        fn_finish_payment($order_id, $pp_response);
        fn_order_placement_routines('route', $order_id, false);
    }

    exit;

} else {

    $rbsPayment = new RBSPayment($processor_data);
    $response = $rbsPayment->register($order_info);

    if (!empty($processor_data['processor_params']['logging']) && $processor_data['processor_params']['logging'] == 'Y') {
        RBSPayment::writeLog($response, 'REGISTER ');
    }

    if (!$rbsPayment->isError()) {

        $pp_response = array(
            'transaction_id' => $response['orderId']
        );

        fn_update_order_payment_info($order_id, $pp_response);
        fn_create_payment_form($response['formUrl'], array(), '', true, 'GET');

    } else {
        $pp_response['order_status'] = 'F';
        $pp_response['reason_text'] = $rbsPayment->getErrorText();

        fn_finish_payment($order_id, $pp_response);
        fn_order_placement_routines('route', $order_id, false);
    }

}

